-- Evaluator by Jeffrey Fielding (JJProg@cyberbury.net)
-- Evaluates Euphoria expressions, calling routines and accessing variables
-- as nessicary using customizeable routines, uses same order of operations
-- as Euphoria
-- version 1.0
include get.e
include tokens.e
sequence onEncounter, operations, importantOperators
onEncounter = {}
operations = {}
importantOperators = {}
constant ENCOUNTER_TOKEN = 1, ENCOUNTER_CALL = 2, ENCONTER_PASS_FIRST = 3
constant NOT_NUMERIC = 0, NUMERIC = 1, INVALID_FORMAT = -1
function isNumeric(sequence t)
    integer n
    if t[1] = '-' then
	t = t[2..length(t)]
    end if
    if length(t) = 0 then
	return NOT_NUMERIC
    end if
    if t[1] = '#' then
	for i = 2 to length(t) do
	    if not find(t[i],"ABCDEF1234567890") then
		return INVALID_FORMAT
	    end if
	end for
	return NUMERIC
    else
	n = 0
	for i = 1 to length(t) do
	    if t[i] = '.' then
		if n = 1 then
		    return INVALID_FORMAT
		end if
		n = 1
	    elsif not find(t[i],"0123456789.") then
		if i > 1 then
		    return INVALID_FORMAT
		else
		    return NOT_NUMERIC
		end if
	    end if
	end for
	return NUMERIC
    end if
end function
global function eval(sequence tokens)
    integer n, f, u, f2
    object first, second, third
    sequence operation, special
    trace(1)
    operation = ""
    f = 0
    n = 1
    if isNumeric(tokens[n][1]) = NUMERIC then
	first = value(tokens[n][1])
	first = first[2]
	n = n + 1
    elsif isNumeric(tokens[n][1]) = INVALID_FORMAT then
	return {INVALID_FORMAT,0,0}
    else
	for i = 1 to length(onEncounter) do
	    trace(1)
	    if compare(tokens[n][1],onEncounter[i][1]) = 0 then
		if onEncounter[i][3] then
		    first = call_func(onEncounter[i][2],{tokens,n,first})
		else
		    first = call_func(onEncounter[i][2],{tokens,n})
		end if
		if first[1] != 0 then
		    return {first[1],0,0}
		end if
		n = first[2]
		first = first[3]
		exit
	    end if
	end for
	--return {INVALID_FORMAT,0,0}
    end if
    while length(tokens) >= n do
	trace(1)
	f = 0
	for i = 1 to length(operations) do
	    if compare(operations[i][1],tokens[n][1]) = 0 then
		f = i
		operation = tokens[n][1]
		n = n + 1
		exit
	    end if
	end for
	if f = 0 then
	    for i = 1 to length(onEncounter) do
		if compare(onEncounter[i][1],tokens[n][1]) = 0 then
		    if onEncounter[i][3] then
			first = call_func(onEncounter[i][2],{tokens,n,first})
		    else
			first = call_func(onEncounter[i][2],{tokens,n})
		    end if
		    if first[1] != 0 then
			return {first[1],0,0}
		    end if
		    n = first[2]
		    first = first[3]
		    exit
		end if
	    end for
	    exit
	else
	    exit
	end if
    end while
    while n <= length(tokens) do
	trace(1)
	if length(operation) = 0 then
	    operation = tokens[n][1]
	    f = 0
	    for i = 1 to length(operations) do
		if compare(operations[i][1],operation) = 0 then
		    f = i
		    exit
		end if
	    end for
	    n = n + 1
	    if f = 0 then
		operation = ""
		exit
	    end if
	else
	    if isNumeric(tokens[n][1]) = NUMERIC then
		second = value(tokens[n][1])
		second = second[2]
		n = n + 1
	    elsif isNumeric(tokens[n][1]) = INVALID_FORMAT then
		return {INVALID_FORMAT,0,0}
	    else
		for i = 1 to length(onEncounter) do
		    if compare(tokens[n][1],onEncounter[i][1]) = 0 then
			if onEncounter[i][3] then
			    second = call_func(onEncounter[i][2],{tokens,n,second})
			else
			    second = call_func(onEncounter[i][2],{tokens,n})
			end if
			if second[1] != 0 then
			    return {second[1],0,0}
			end if
			n = second[2]
			second = second[3]
			exit
		    end if
		end for
		--return {INVALID_FORMAT,0,0}
	    end if
	    while length(tokens) >= n do
		f2 = 0
		for i = 1 to length(operations) do
		    if compare(operations[i][1],tokens[n][1]) = 0 then
			f2 = i
			special = tokens[n][1]
			n = n + 1
			exit
		    end if
		end for
		if f2 = 0 then
		    for i = 1 to length(onEncounter) do
			if compare(onEncounter[i][1],tokens[n][1]) = 0 then
			    if onEncounter[i][3] then
				second = call_func(onEncounter[i][2],{tokens,n,second})
			    else
				second = call_func(onEncounter[i][2],{tokens,n})
			    end if
			    if second[1] != 0 then
				return {second[1],0,0}
			    end if
			    n = second[2]
			    second = second[3]
			    exit
			end if
		    end for
		    exit
		else
		    exit
		end if
	    end while
	    u = n
	    special = ""
	    while length(tokens) >= n do
		trace(1)
		if u > length(tokens) then
		    exit
		end if
		if length(special) = 0 then
		    special = tokens[u][1]
		    if not find(special,importantOperators) then
			exit
		    end if
		    f2 = 0
		    for i = 1 to length(operations) do
			if compare(operations[i][1],special) = 0 then
			    f2 = i
			    exit
			end if
		    end for
		    u = u + 1
		else
		    if isNumeric(tokens[u][1]) = NUMERIC then
			third = value(tokens[u][1])
			third = third[2]
			u = u + 1
		    elsif isNumeric(tokens[u][1]) = INVALID_FORMAT then
			return {INVALID_FORMAT,0,0}
		    else
			for i = 1 to length(onEncounter) do
			    if compare(tokens[u][1],onEncounter[i][1]) = 0 then
				if onEncounter[i][3] then
				    third = call_func(onEncounter[i][2],{tokens,n,third})
				else
				    third = call_func(onEncounter[i][2],{tokens,n})
				end if
				third = call_func(onEncounter[i][2],{third,u})
				if third[1] != 0 then
				    return {third[1],0,0}
				end if
				u = third[2]
				third = third[3]
				exit
			    end if
			end for
			--return {INVALID_FORMAT,0,0}
		    end if
		    while length(tokens) >= n do
			f2 = 0
			for i = 1 to length(operations) do
			    if compare(operations[i][1],tokens[u][1]) = 0 then
				f2 = i
				special = tokens[u][1]
				u = u + 1
				exit
			    end if
			end for
			if f2 = 0 then
			    for i = 1 to length(onEncounter) do
				if compare(onEncounter[i][1],tokens[u][1]) = 0 then
				    if onEncounter[i][3] then
					third = call_func(onEncounter[i][2],{tokens,n,third})
				    else
					third = call_func(onEncounter[i][2],{tokens,n})
				    end if
				    if third[1] != 0 then
					return {third[1],0,0}
				    end if
				    u = third[2]
				    third = third[3]
				    exit
				end if
			    end for
			    exit
			else
			    exit
			end if
		    end while
		    second = call_func(operations[f2][2],{second,third})
		    if second[1] != 0 then
			return {second[1],0,0}
		    end if
		    second = second[2]
		    special = ""
		end if
	    end while
	    n = u
	    first = call_func(operations[f][2],{first,second})
	    if first[1] != 0 then
		return {first[1],0,0}
	    end if
	    first=first[2]
	    operation = ""
	end if
    end while
    if length(operation) then
	return {INVALID_FORMAT,0,0}
    else
	return {0,n,first}
    end if
end function
global function evalFirst(sequence tokens)
    integer n, f
    object first
    trace(1)
    n = 1
    if isNumeric(tokens[n][1]) = NUMERIC then
	first = value(tokens[n][1])
	first = first[2]
	n = n + 1
    elsif isNumeric(tokens[n][1]) = INVALID_FORMAT then
	return {INVALID_FORMAT,0,0}
    else
	for i = 1 to length(onEncounter) do
	    if compare(tokens[n][1],onEncounter[i][1]) = 0 then
		if onEncounter[i][3] then
		    first = call_func(onEncounter[i][2],{tokens,n,first})
		else
		    first = call_func(onEncounter[i][2],{tokens,n})
		end if
		if first[1] != 0 then
		    return {first[1],0,0}
		end if
		n = first[2]
		first = first[3]
		exit
	    end if
	end for
	--return {INVALID_FORMAT,0,0}
    end if
    while length(tokens) >= n do
	f = 0
	for i = 1 to length(operations) do
	    if compare(operations[i][1],tokens[n][1]) = 0 then
		f = i
		--operation = tokens[n][1]
		--n = n + 1
		exit
	    end if
	end for
	if f = 0 then
	    for i = 1 to length(onEncounter) do
		if compare(onEncounter[i][1],tokens[n][1]) = 0 then
		    if onEncounter[i][3] then
			first = call_func(onEncounter[i][2],{tokens,n,first})
		    else
			first = call_func(onEncounter[i][2],{tokens,n})
		    end if
		    if first[1] != 0 then
			return {first[1],0,0}
		    end if
		    n = first[2]
		    first = first[3]
		    exit
		end if
	    end for
	    exit
	else
	    exit
	end if
    end while
    return {0,n,first}
end function
function add(object a, object b)
    return {0,a + b}
end function
operations = append(operations,{"+",routine_id("add")})
function sub(object a, object b)
    return {0,a - b}
end function
operations = append(operations,{"-",routine_id("sub")})
function mul(object a, object b)
    return {0,a * b}
end function
operations = append(operations,{"*",routine_id("mul")})
importantOperators = append(importantOperators,"*")
function div(object a, object b)
    return {0,a / b}
end function
operations = append(operations,{"/",routine_id("div")})
importantOperators = append(importantOperators,"/")
function addElement(object a, object b)
    return {0,a & b}
end function
operations = append(operations,{"&",routine_id("addElement")})
global constant MUST_BE_ATOMS = 2
function equ(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a = b}
end function
operations = append(operations,{"=",routine_id("equ")})
function notequ(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a != b}
end function
operations = append(operations,{"!=",routine_id("notequ")})
function mequ(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a >= b}
end function
operations = append(operations,{">=",routine_id("mequ")})
function lequ(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a <= b}
end function
operations = append(operations,{"<=",routine_id("lequ")})
function more(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a > b}
end function
operations = append(operations,{">",routine_id("more")})
function less(object a, object b)
    if not atom(a) or not atom(b) then
	return {MUST_BE_ATOMS,0}
    end if
    return {0,a < b}
end function
operations = append(operations,{"<",routine_id("less")})
function andop(object a, object b)
    return {0,a and b}
end function
operations = append(operations,{"and",routine_id("andop")})
function orop(object a, object b)
    return {0,a or b}
end function
operations = append(operations,{"or",routine_id("orop")})
function xorop(object a, object b)
    return {0,a xor b}
end function
operations = append(operations,{"xor",routine_id("xorop")})
function onEncounterParens(sequence tokens, integer n)
    sequence s
    s = eval(tokens[n+1..length(tokens)])
    return {s[1],s[2]+n,s[3]}
end function
onEncounter = append(onEncounter,{"(",routine_id("onEncounterParens"),0})
function onEncounterSequence(sequence tokens, integer n)
    sequence s, r
    trace(1)
    r = {}
    while compare(tokens[n][1],"}") do
	trace(1)
	n = n + 1
	s = eval(tokens[n..length(tokens)])
	if s[1] then
	    return {s[1],0,0}
	end if
	r = append(r,s[3])
	n = s[2]+n-2
    end while
    return {0,n+1,r}
end function
onEncounter = append(onEncounter,{"{",routine_id("onEncounterSequence"),0})
function onEncounterNegitive(sequence tokens, integer n)
    sequence s
    s = evalFirst(tokens[n+1..length(tokens)])
    return {s[1],s[2]+n,-s[3]}
end function
onEncounter = append(onEncounter,{"-",routine_id("onEncounterNegitive"),0})
function onEncounterIndex(sequence tokens, integer n, object first)
    sequence s,e
    s = eval(tokens[n+1..length(tokens)])
    if s[1] then
	return {s[1],s[2]+n,s[3]}
    end if
    n = s[2]+n-1
    if compare(tokens[n][1],"..") = 0 then
	e = evalFirst(tokens[n+1..length(tokens)])
	if e[1] then
	    return {e[1],e[2]+n,e[3]}
	end if
	return {0,e[2]+n,first[s[3]..e[3]]}
    end if
    return {s[1],s[2]+n,first[s[3]]}
end function
onEncounter = append(onEncounter,{"[",routine_id("onEncounterIndex"),1})
function onEncounterNot(sequence tokens, integer n)
    sequence s
    s = evalFirst(tokens[n+1..length(tokens)])
    return {s[1],s[2]+n,not s[3]}
end function
onEncounter = append(onEncounter,{"not",routine_id("onEncounterNot"),0})
